diff --git a/base/deploy/src/scriptlets/pkiconfig.py b/base/deploy/src/scriptlets/pkiconfig.py
index 7d676c0..281c371 100644
--- a/base/deploy/src/scriptlets/pkiconfig.py
+++ b/base/deploy/src/scriptlets/pkiconfig.py
@@ -38,28 +38,63 @@ PKI_DEPLOYMENT_VERBOSITY=\
 PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS = 00770
 PKI_DEPLOYMENT_DEFAULT_EXE_PERMISSIONS = 00770
 PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS = 00660
+PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS = 00777
 PKI_DEPLOYMENT_DEFAULT_UMASK = 00002
+PKI_DEPLOYMENT_DEFAULT_LOG_PATH = "/dev"
+PKI_DEPLOYMENT_DEFAULT_LOG_NAME = "null"
+PKI_DEPLOYMENT_CSV_EXTENSION = "csv"
+PKI_DEPLOYMENT_LOG_EXTENSION = "log"
+
+PKI_INDENTATION_LEVEL_0 = {'indent' : ''}
+PKI_INDENTATION_LEVEL_1 = {'indent' : '... '}
+PKI_INDENTATION_LEVEL_2 = {'indent' : '....... '}
+PKI_INDENTATION_LEVEL_3 = {'indent' : '........... '}
+PKI_INDENTATION_LEVEL_4 = {'indent' : '............... '}
 
 PKIDESTROY_PATH = PKI_DEPLOYMENT_PATH + "/" + "destroy"
 PKIDESTROY_LOG_PATH = "/var/log"
 PKIDESTROY_LOG_PREFIX = "pki-"
-PKIDESTROY_LOG_SUFFIX = "-destroy.log"
+PKIDESTROY_LOG_SUFFIX = "-destroy"
 PKIDESTROY_LOGGER = "pkidestroy"
 
 PKIRESPAWN_PATH = PKI_DEPLOYMENT_PATH + "/" + "spawn"
 PKIRESPAWN_LOG_PATH = "/var/log"
 PKIRESPAWN_LOG_PREFIX = "pki-"
-PKIRESPAWN_LOG_SUFFIX = "-respawn.log"
+PKIRESPAWN_LOG_SUFFIX = "-respawn"
 PKIRESPAWN_LOGGER = "pkirespawn"
+PKIRESPAWN = "respawn"
 
 PKISPAWN_PATH = PKI_DEPLOYMENT_PATH + "/" + "spawn"
 PKISPAWN_LOG_PATH = "/var/log"
 PKISPAWN_LOG_PREFIX = "pki-"
-PKISPAWN_LOG_SUFFIX = "-spawn.log"
+PKISPAWN_LOG_SUFFIX = "-spawn"
 PKISPAWN_LOGGER = "pkispawn"
+PKISPAWN = "spawn"
 
+PKI_APACHE = "apache"
+PKI_COMMON_DIR = "common"
+PKI_CONF_DIR = "conf"
+PKI_LIB_DIR = "lib"
+PKI_MANIFEST = "manifest"
 PKI_SECURITY_DATABASE_DIR = "alias"
+PKI_SHARED_CONFIGURATION_ROOT = "/etc/pki"
+PKI_SIGNED_AUDIT_DIR = "signedAudit"
+PKI_TOMCAT = "tomcat"
+PKI_TYPE_DIRECTORY = "directory"
+PKI_TYPE_FILE = "file"
+PKI_TYPE_SYMLINK = "symlink"
+PKI_WEBAPPS_DIR = "webapps"
+PKI_WEBAPPS_ROOT_DIR = PKI_WEBAPPS_DIR + "/" + "ROOT"
+PKI_WEBAPPS_ROOT_WEBINF_DIR = PKI_WEBAPPS_ROOT_DIR + "/" + "WEB-INF"
+PKI_WEBAPPS_WEBINF_DIR = PKI_WEBAPPS_DIR + "/" + "WEB-INF"
+PKI_WEBAPPS_WEBINF_CLASSES_DIR = PKI_WEBAPPS_WEBINF_DIR + "/" + "classes"
+PKI_WEBAPPS_WEBINF_LIB_DIR = PKI_WEBAPPS_WEBINF_DIR + "/" + "lib"
+PKI_WEBINF_DIR = "WEB-INF"
+PKI_WEBINF_CLASSES_DIR = PKI_WEBINF_DIR + "/" + "classes"
+PKI_WEBINF_LIB_DIR = PKI_WEBINF_DIR + "/" + "lib"
+
 PKI_SUBSYSTEMS = ["CA","KRA","OCSP","RA","TKS","TPS"]
+PKI_SIGNED_AUDIT_SUBSYSTEMS = ["CA","KRA","OCSP","TKS","TPS"]
 PKI_APACHE_SUBSYSTEMS = ["RA","TPS"]
 PKI_TOMCAT_SUBSYSTEMS = ["CA","KRA","OCSP","TKS"]
 
diff --git a/base/deploy/src/scriptlets/pkihelper.py b/base/deploy/src/scriptlets/pkihelper.py
index ee2bdd2..cd49048 100644
--- a/base/deploy/src/scriptlets/pkihelper.py
+++ b/base/deploy/src/scriptlets/pkihelper.py
@@ -20,203 +20,371 @@
 #
 
 # System Imports
-import ConfigParser
-import argparse
-import logging
+import sys
 import os
+import shutil
+from grp import getgrnam
+from pwd import getpwnam
 
 
 # PKI Deployment Imports
 import pkiconfig as config
+import pkimanifest as manifest
 import pkimessages as log
 
 
-# PKI Deployment Helper Functions
-def process_command_line_arguments(argv):
-    "Read and process command-line options"
-    description = None
-    if os.path.basename(argv[0]) == 'pkispawn':
-        description = 'PKI Instance Installation and Configuration'
-    elif os.path.basename(argv[0]) == 'pkidestroy':
-        description = 'PKI Instance Removal'
-    parser = argparse.ArgumentParser(
-                 description=description,
-                 add_help=False,
-                 formatter_class=argparse.RawDescriptionHelpFormatter,
-                 epilog=config.PKI_DEPLOYMENT_VERBOSITY)
-    mandatory = parser.add_argument_group('mandatory arguments')
-    mandatory.add_argument('-s',
-                           dest='pki_subsystem', action='store',
-                           nargs=1, choices=config.PKI_SUBSYSTEMS,
-                           required=True, metavar='<subsystem>',
-                           help='where <subsystem> is '
-                                'CA, KRA, OCSP, RA, TKS, or TPS')
-    optional = parser.add_argument_group('optional arguments')
-    optional.add_argument('--dry_run',
-                          dest='pki_dry_run_flag', action='store_true',
-                          help='do not actually perform any actions')
-    optional.add_argument('-f',
-                          dest='pkideployment_cfg', action='store',
-                          nargs=1, metavar='<file>',
-                          help='overrides default configuration filename')
-    optional.add_argument('-h', '--help',
-                          dest='help', action='help',
-                          help='show this help message and exit')
-    optional.add_argument('-p',
-                          dest='pki_root_prefix', action='store',
-                          nargs=1, metavar='<prefix>',
-                          help='directory prefix to specify local directory')
-    if os.path.basename(argv[0]) == 'pkispawn':
-        optional.add_argument('-u',
-                              dest='pki_update_flag', action='store_true',
-                              help='update instance of specified subsystem')
-    optional.add_argument('-v',
-                          dest='pki_verbosity', action='count',
-                          help='display verbose information (details below)')
-    custom = parser.add_argument_group('custom arguments '
-                                       '(OVERRIDES configuration file values)')
-    custom.add_argument('-i',
-                        dest='pki_instance_name', action='store',
-                        nargs=1, metavar='<instance>',
-                        help='PKI instance name (MUST specify REQUIRED ports)')
-    custom.add_argument('--http_port',
-                        dest='pki_http_port', action='store',
-                        nargs=1, metavar='<port>',
-                        help='HTTP port (CA, KRA, OCSP, RA, TKS, TPS)')
-    custom.add_argument('--https_port',
-                        dest='pki_https_port', action='store',
-                        nargs=1, metavar='<port>',
-                        help='HTTPS port (CA, KRA, OCSP, RA, TKS, TPS)')
-    custom.add_argument('--ajp_port',
-                        dest='pki_ajp_port', action='store',
-                        nargs=1, metavar='<port>',
-                        help='AJP port (CA, KRA, OCSP, TKS)')
-    args = parser.parse_args()
-
-    config.pki_subsystem = str(args.pki_subsystem).strip('[\']')
-    if args.pki_dry_run_flag:
-        config.pki_dry_run_flag = args.pki_dry_run_flag
-    if not args.pkideployment_cfg is None:
-        config.pkideployment_cfg = str(args.pkideployment_cfg).strip('[\']')
-    if not os.path.exists(config.pkideployment_cfg) or\
-       not os.path.isfile(config.pkideployment_cfg):
-        print "ERROR:  " +\
-              log.PKI_FILE_MISSING_OR_NOT_A_FILE_1 %\
-              config.pkideployment_cfg
-        print
-        parser.print_help()
-        parser.exit(-1);
-    if not args.pki_root_prefix is None:
-        config.pki_root_prefix = str(args.pki_root_prefix).strip('[\']')
-    if config.pki_root_prefix is None or\
-       len(config.pki_root_prefix) == 0:
-        config.pki_root_prefix = ""
-    elif not os.path.exists(config.pki_root_prefix) or\
-         not os.path.isdir(config.pki_root_prefix):
-        print "ERROR:  " +\
-              log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1 %\
-              config.pki_root_prefix
-        print
-        parser.print_help()
-        parser.exit(-1);
-    if os.path.basename(argv[0]) == 'pkispawn':
-        if args.pki_update_flag:
-            config.pki_update_flag = args.pki_update_flag
-    if args.pki_verbosity == 1:
-        config.pki_console_log_level = logging.INFO
-        config.pki_log_level = logging.INFO
-    elif args.pki_verbosity == 2:
-        config.pki_console_log_level = logging.INFO
-        config.pki_log_level = logging.DEBUG
-    elif args.pki_verbosity == 3:
-        config.pki_console_log_level = logging.DEBUG
-        config.pki_log_level = logging.DEBUG
-    elif args.pki_verbosity > 3:
-        print "ERROR:  " + log.PKI_VERBOSITY_LEVELS_MESSAGE
-        print
-        parser.print_help()
-        parser.exit(-1);
-    if not args.pki_instance_name is None:
-        config.pki_instance_name = str(args.pki_instance_name).strip('[\']')
-    if not args.pki_http_port is None:
-        config.pki_http_port = str(args.pki_http_port).strip('[\']')
-    if not args.pki_https_port is None:
-        config.pki_https_port = str(args.pki_https_port).strip('[\']')
-    if not args.pki_ajp_port is None:
-        if config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
-            config.pki_ajp_port = str(args.pki_ajp_port).strip('[\']')
-        else:
-            print "ERROR:  " +\
-                  log.PKI_CUSTOM_TOMCAT_AJP_PORT_1 %\
-                  config.pki_subsystem
-            print
-            parser.print_help()
-            parser.exit(-1);
-    if not args.pki_instance_name is None or\
-       not args.pki_http_port is None or\
-       not args.pki_https_port is None or\
-       not args.pki_ajp_port is None:
-        if config.pki_subsystem in config.PKI_APACHE_SUBSYSTEMS:
-            if args.pki_instance_name is None or\
-               args.pki_http_port is None or\
-               args.pki_https_port is None:
-                print "ERROR:  " + log.PKI_CUSTOM_APACHE_INSTANCE_1 %\
-                      config.pki_subsystem
-                print
-                parser.print_help()
-                parser.exit(-1);
-        elif config.pki_subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
-            if args.pki_instance_name is None or\
-               args.pki_http_port is None or\
-               args.pki_https_port is None or\
-               args.pki_ajp_port is None:
-                print "ERROR:  " + log.PKI_CUSTOM_TOMCAT_INSTANCE_1 %\
-                      config.pki_subsystem
-                print
-                parser.print_help()
-                parser.exit(-1);
-
-
-def read_pki_configuration_file():
-    "Read configuration file sections into dictionaries"
-    rv = 0
-    try:
-        parser = ConfigParser.ConfigParser()
-        parser.read(config.pkideployment_cfg)
-        config.pki_common_dict = dict(parser._sections['Common'])
-        if config.pki_subsystem == "CA":
-            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
-            config.pki_subsystem_dict = dict(parser._sections['CA'])
-        elif config.pki_subsystem == "KRA":
-            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
-            config.pki_subsystem_dict = dict(parser._sections['KRA'])
-        elif config.pki_subsystem == "OCSP":
-            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
-            config.pki_subsystem_dict = dict(parser._sections['OCSP'])
-        elif config.pki_subsystem == "RA":
-            config.pki_web_server_dict = dict(parser._sections['Apache'])
-            config.pki_subsystem_dict = dict(parser._sections['RA'])
-        elif config.pki_subsystem == "TKS":
-            config.pki_web_server_dict = dict(parser._sections['Tomcat'])
-            config.pki_subsystem_dict = dict(parser._sections['TKS'])
-        elif config.pki_subsystem == "TPS":
-            config.pki_web_server_dict = dict(parser._sections['Apache'])
-            config.pki_subsystem_dict = dict(parser._sections['TPS'])
-        # Insert empty record into dictionaries for "pretty print" statements
-        config.pki_common_dict[0] = None
-        config.pki_web_server_dict[0] = None
-        config.pki_subsystem_dict[0] = None
-    except ConfigParser.ParsingError, err:
-        rv = err
-    return rv
-
-
-def create_pki_master_dictionary():
-    "Create a single master PKI dictionary from the sectional dictionaries"
-    config.pki_master_dict = dict()
-    config.pki_master_dict.update(config.pki_common_dict)
-    config.pki_master_dict.update(config.pki_web_server_dict)
-    config.pki_master_dict.update(config.pki_subsystem_dict)
-    config.pki_master_dict.update(__name__="PKI Master Dictionary")
-    return
+# PKI Deployment Identity Class
+class identity:
+    def get_uid(self, critical_failure=True):
+        try:
+            pki_uid = config.pki_master_dict['pki_uid']
+        except KeyError as exc:
+            config.pki_log.error(log.PKI_KEYERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return pki_uid
+
+    def get_gid(self, critical_failure=True):
+        try:
+            pki_gid = config.pki_master_dict['pki_gid']
+        except KeyError as exc:
+            config.pki_log.error(log.PKI_KEYERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return pki_gid
+
+    def set_uid(self, name, critical_failure=True):
+        try:
+            config.pki_log.debug(log.PKIHELPER_USER_1, name,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            # id -u <name>
+            pki_uid = getpwnam(name)[2]
+            config.pki_master_dict['pki_uid']=pki_uid
+            config.pki_log.debug(log.PKIHELPER_UID_2, name, pki_uid,
+                                 extra=config.PKI_INDENTATION_LEVEL_3)
+        except KeyError as exc:
+            config.pki_log.error(log.PKI_KEYERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return pki_uid
+
+    def set_gid(self, name, critical_failure=True):
+        try:
+            config.pki_log.debug(log.PKIHELPER_GROUP_1, name,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            # id -g <name>
+            pki_gid = getgrnam(name)[2]
+            config.pki_master_dict['pki_gid']=pki_gid
+            config.pki_log.debug(log.PKIHELPER_GID_2, name, pki_gid,
+                                 extra=config.PKI_INDENTATION_LEVEL_3)
+        except KeyError as exc:
+            config.pki_log.error(log.PKI_KEYERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return pki_gid
+
+
+# PKI Deployment Instance Class
+class instance:
+    def apache_instances(self, name):
+        rv = 0
+        try:
+            if not os.path.exists(name) or not os.path.isdir(name):
+                config.pki_log.error(
+                    log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, name,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            # count number of PKI subsystems present
+            # within the specfied Apache instance
+            for subsystem in config.PKI_APACHE_SUBSYSTEMS:
+                path = name + "/" + subsystem.lower()
+                if os.path.exists(path) and os.path.isdir(path):
+                    rv = rv + 1
+            # always display correct information (even during dry_run)
+            if config.pki_dry_run_flag and rv > 0:
+                config.pki_log.debug(log.PKIHELPER_APACHE_INSTANCES_2,
+                                     name, rv - 1,
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+            else:
+                config.pki_log.debug(log.PKIHELPER_APACHE_INSTANCES_2, name,
+                                     rv, extra=config.PKI_INDENTATION_LEVEL_2)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+        return rv
+
+    def pki_subsystem_instances(self, name):
+        rv = 0
+        try:
+            if not os.path.exists(name) or not os.path.isdir(name):
+                config.pki_log.error(
+                    log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, name,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            # count total number of PKI subsystems present
+            # within the specfied PKI instance
+            for subsystem in config.PKI_SUBSYSTEMS:
+                path = name + "/" + subsystem.lower()
+                if os.path.exists(path) and os.path.isdir(path):
+                    rv = rv + 1
+            # always display correct information (even during dry_run)
+            if config.pki_dry_run_flag and rv > 0:
+                config.pki_log.debug(log.PKIHELPER_PKI_SUBSYSTEM_INSTANCES_2,
+                                     name, rv - 1,
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+            else:
+                config.pki_log.debug(log.PKIHELPER_PKI_SUBSYSTEM_INSTANCES_2,
+                                     name, rv,
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+        return rv
+
+    def tomcat_instances(self, name):
+        rv = 0
+        try:
+            if not os.path.exists(name) or not os.path.isdir(name):
+                config.pki_log.error(
+                    log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, name,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            # count number of PKI subsystems present
+            # within the specfied Tomcat instance
+            for subsystem in config.PKI_TOMCAT_SUBSYSTEMS:
+                path = name + "/" + subsystem.lower()
+                if os.path.exists(path) and os.path.isdir(path):
+                    rv = rv + 1
+            # always display correct information (even during dry_run)
+            if config.pki_dry_run_flag and rv > 0:
+                config.pki_log.debug(log.PKIHELPER_TOMCAT_INSTANCES_2,
+                                     name, rv - 1,
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+            else:
+                config.pki_log.debug(log.PKIHELPER_TOMCAT_INSTANCES_2, name,
+                                     rv, extra=config.PKI_INDENTATION_LEVEL_2)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+        return rv
+
+
+# PKI Deployment Directory Class
+class directory:
+    def create(self, name, uid=None, gid=None,
+               perms=config.PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS,
+               acls=None, critical_failure=True):
+        try:
+            if not os.path.exists(name):
+                # mkdir -p <name>
+                config.pki_log.info(log.PKIHELPER_MKDIR_1, name,
+                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                if not config.pki_dry_run_flag:
+                    os.makedirs(name)
+                # chmod <perms> <name>
+                config.pki_log.debug(log.PKIHELPER_CHMOD_2, perms, name,
+                                     extra=config.PKI_INDENTATION_LEVEL_3)
+                if not config.pki_dry_run_flag:
+                    os.chmod(name, perms)
+                # chown <uid>:<gid> <name>
+                if uid == None:
+                    uid = identity.get_uid()
+                if gid == None:
+                    gid = identity.get_gid()
+                config.pki_log.debug(log.PKIHELPER_CHOWN_3,
+                                     uid, gid, name,
+                                     extra=config.PKI_INDENTATION_LEVEL_3)
+                if not config.pki_dry_run_flag:
+                    os.chown(name, uid, gid)
+                # Store record in installation manifest
+                record = manifest.record()
+                record.name = name
+                record.type = config.PKI_TYPE_DIRECTORY
+                record.user = config.pki_master_dict['pki_user']
+                record.group = config.pki_master_dict['pki_group']
+                record.uid = uid
+                record.gid = gid
+                record.permissions = perms
+                record.acls = acls
+                manifest.database.append(record)
+            elif not os.path.isdir(name):
+                config.pki_log.error(
+                    log.PKI_DIRECTORY_ALREADY_EXISTS_NOT_A_DIRECTORY_1, name,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                if critical_failure == True:
+                    sys.exit(1)
+            else:
+                config.pki_log.error(log.PKI_DIRECTORY_ALREADY_EXISTS_1, name,
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+                if critical_failure == True:
+                    sys.exit(1)
+        except OSError as exc:
+            if exc.errno == errno.EEXIST:
+                pass
+            else:
+                config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                     extra=config.PKI_INDENTATION_LEVEL_2)
+                if critical_failure == True:
+                    sys.exit(1)
+        return
+
+    def modify(self, name, uid=None, gid=None,
+               perms=config.PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS,
+               acls=None, critical_failure=True):
+        try:
+            if os.path.exists(name):
+                if not os.path.isdir(name):
+                    config.pki_log.error(
+                        log.PKI_DIRECTORY_ALREADY_EXISTS_NOT_A_DIRECTORY_1,
+                        name, extra=config.PKI_INDENTATION_LEVEL_2)
+                    if critical_failure == True:
+                        sys.exit(1)
+                # Always re-process each directory whether it needs it or not
+                config.pki_log.info(log.PKIHELPER_MODIFY_DIR_1, name,
+                                    extra=config.PKI_INDENTATION_LEVEL_2)
+                # chmod <perms> <name>
+                config.pki_log.debug(log.PKIHELPER_CHMOD_2, perms, name,
+                                     extra=config.PKI_INDENTATION_LEVEL_3)
+                if not config.pki_dry_run_flag:
+                    os.chmod(name, perms)
+                # chown <uid>:<gid> <name>
+                if uid == None:
+                    uid = identity.get_uid()
+                if gid == None:
+                    gid = identity.get_gid()
+                config.pki_log.debug(log.PKIHELPER_CHOWN_3,
+                                     uid, gid, name,
+                                     extra=config.PKI_INDENTATION_LEVEL_3)
+                if not config.pki_dry_run_flag:
+                    os.chown(name, uid, gid)
+                # Store record in installation manifest
+                record = manifest.record()
+                record.name = name
+                record.type = config.PKI_TYPE_DIRECTORY
+                record.user = config.pki_master_dict['pki_user']
+                record.group = config.pki_master_dict['pki_group']
+                record.uid = uid
+                record.gid = gid
+                record.permissions = perms
+                record.acls = acls
+                manifest.database.append(record)
+            else:
+                config.pki_log.error(
+                    log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, name,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                if critical_failure == True:
+                    sys.exit(1)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return
+
+    def delete(self, name, recursive_flag=True, critical_failure=True):
+        try:
+            if not os.path.exists(name) or not os.path.isdir(name):
+                config.pki_log.error(
+                    log.PKI_DIRECTORY_MISSING_OR_NOT_A_DIRECTORY_1, name,
+                    extra=config.PKI_INDENTATION_LEVEL_2)
+                sys.exit(1)
+            else:
+                if recursive_flag == True:
+                    # rm -rf <name>
+                    config.pki_log.info(log.PKIHELPER_RM_RF_1, name,
+                                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    if not config.pki_dry_run_flag:
+                        shutil.rmtree(name)
+                else:
+                    # rmdir <name>
+                    config.pki_log.info(log.PKIHELPER_RMDIR_1, name,
+                                        extra=config.PKI_INDENTATION_LEVEL_2)
+                    if not config.pki_dry_run_flag:
+                        os.rmdir(name)
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            if critical_failure == True:
+                sys.exit(1)
+        return
+
+    def is_empty(self, name):
+        try:
+            if not os.listdir(name):
+                config.pki_log.debug(log.PKIHELPER_DIRECTORY_IS_NOT_EMPTY_1,
+                                     name, extra=config.PKI_INDENTATION_LEVEL_2)
+                return False
+            else:
+                config.pki_log.debug(log.PKIHELPER_DIRECTORY_IS_EMPTY_1,
+                                     name, extra=config.PKI_INDENTATION_LEVEL_2)
+                return True
+        except OSError as exc:
+            config.pki_log.error(log.PKI_OSERROR_1, exc,
+                                 extra=config.PKI_INDENTATION_LEVEL_2)
+            sys.exit(1)
+
+    def copy(self, old_name, new_name, uid=None, gid=None,
+             perms=config.PKI_DEPLOYMENT_DEFAULT_DIR_PERMISSIONS, acls=None,
+             recursive_flag=True, overwrite_flag=True, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+
+# PKI Deployment File Class (also used for executables)
+class file:
+    def create(self, name, uid=None, gid=None,
+               perms=config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
+               acls=None, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+    def modify(self, name, uid=None, gid=None,
+               perms=config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS,
+               acls=None, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+    def delete(self, name, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+    def copy(self, old_name, new_name, uid=None, gid=None,
+             perms=config.PKI_DEPLOYMENT_DEFAULT_FILE_PERMISSIONS, acls=None,
+             overwrite_flag=True, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+
+# PKI Deployment Symbolic Link Class
+class symlink:
+    def create(self, name, link, uid=None, gid=None,
+               perms=config.PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS,
+               acls=None, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+    def modify(self, name, link, uid=None, gid=None,
+               perms=config.PKI_DEPLOYMENT_DEFAULT_SYMLINK_PERMISSIONS,
+               acls=None, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+    def delete(self, link, critical_failure=True):
+        ### NOT YET IMPLEMENTED
+        return
+
+
+# PKI Deployment Helper Class Instances
+identity = identity()
+instance = instance()
+directory = directory()
+file = file()
+symlink = symlink()
 
diff --git a/base/deploy/src/scriptlets/pkilogging.py b/base/deploy/src/scriptlets/pkilogging.py
index 776677c..cd6ad5f 100644
--- a/base/deploy/src/scriptlets/pkilogging.py
+++ b/base/deploy/src/scriptlets/pkilogging.py
@@ -31,16 +31,37 @@ def enable_pki_logger(log_dir, log_name, log_level, console_log_level, logger):
             os.makedirs(log_dir)
         except OSError:
             return OSError
+
+    # Establish 'file' logger using 'basicConfig()'
+    logging.LoggerAdapter(logging.getLogger(''), {'indent' : ''})
     logging.basicConfig(level=log_level,
                         format='%(asctime)s %(name)-12s ' +\
-                               '%(levelname)-8s %(message)s',
+                               '%(levelname)-8s ' +\
+                               '%(indent)s%(message)s',
                         datefmt='%Y-%m-%d %H:%M:%S',
                         filename=log_dir + "/" + log_name,
                         filemode='w')
+
+    # Establish 'console' logger
     console = logging.StreamHandler()
+    logging.LoggerAdapter(console, {'indent' : ''})
     console.setLevel(console_log_level)
-    formatter = logging.Formatter('%(name)-12s: %(levelname)-8s %(message)s')
-    console.setFormatter(formatter)
+    console_format = logging.Formatter('%(name)-12s: ' +\
+                                       '%(levelname)-8s ' +\
+                                       '%(indent)s%(message)s')
+    console.setFormatter(console_format)
     logging.getLogger('').addHandler(console)
+
+    # Establish 'file' logger
+#   file = logging.FileHandler(log_dir + "/" + log_name, 'w')
+#   logging.LoggerAdapter(file, {'indent' : ''})
+#   file.setLevel(log_level)
+#   file_format = logging.Formatter('%(asctime)s %(name)-12s: ' +\
+#                                   '%(levelname)-8s ' +\
+#                                   '%(indent)s%(message)s',
+#                                   '%Y-%m-%d %H:%M:%S')
+#   file.setFormatter(file_format)
+#   logging.getLogger('').addHandler(file)
+
     return logging.getLogger(logger)
 
